<!doctype html>
<html>
<head>
    <title>정경헌 1코스 17강 예제</title>
    <meta charset="utf-8">
<body>
<div></div>
<script>
    // 1) 홀수개의 가로,세로 갯수를 갖는 2차원 배열을 준비한다.
    let mazeWidth = 119;
    let mazeHeight = 59;
    // 스택을 만든다.
    let s = [];
    // 메모리에 미로 판을 만든다.
    let board = [];
    // 2) 모든 셀을 “방문하지 않음(=0)” 상태로 만든다.
    for (let y = 0; y < mazeHeight; y += 1) {
        board.push([]);
        for (let x = 0; x < mazeWidth; x += 1) {
            board[y].push(0);
        }
    }
    // 3) 랜덤한 x,y좌표가 모두 홀수이면서 최외각이 아닌 셀을 랜덤으로 하나 선택하고, 그 셀을 “방문함(=1)” 상태로 만든다.
    let x, y;
    // 램덤한 홀수값을 찾기 위해서 가저온 값이 홀수가 되는 값을 찾을 때 까지 반복한다.
    while (1) {
        // 최외각 가로 0과 119, 세로 0과 59를 제외한 램덤 값을 좌표로 만든다.
        x = getRandom(1, mazeWidth - 2);
        y = getRandom(1, mazeHeight - 2);
        // 홀수값을 찾으면 반복을 빠져나온다.
        if (x % 2 === 1 && y % 2 === 1) break;
    }
    // 홀수인 x, y 좌표를 방문함(=1) 상태로 만든다.
    board[y][x] = 1;
    // 4) 그 셀를 스택에 넣는다. 스택에 들어간 x, y 좌표를 나중에 확인하기 위해서 넣는것
    s.push({x: x, y: y});
    // 5) 스택에 들어간 데이터가 모두 pop 될때까지 반복
    while (s.length) {
        //     5-1) 스택에서 셀을 하나 꺼낸다. 그 셀을 "기준 셀"이라 한다.
        let baseCell = s.pop();
        //     5-2) 기준 셀로부터 "이동 가능한 방향"중 한 방향을 랜덤하게 선택한다.
        //         "이동 가능한 방향"이란, 한 방향으로 첫번째칸과 두번째칸이 둘 다  a)“방문안함” 상태이고 b)미로의 최외곽선이 아닌 경우, 이동 가능한 방향이다.
        let direction = getMovableDirection(baseCell);
        if (direction !== null) {
            // 5-2-1) 선택된 방향으로 인접한 첫번째칸과 두번째칸을 “방문함” 상태로 만들고,
            // 5-2-2) 기준 셀을 스택에 넣고,
            // 5-2-3) 두번째칸을 스택에 넣고 5번으로 돌아간다.
            if (direction === "up") {
                board[baseCell.y - 1][baseCell.x] = 1;
                board[baseCell.y - 2][baseCell.x] = 1;
                s.push(baseCell);
                s.push({x: baseCell.x, y: baseCell.y - 2});
            };
            if (direction === "down") {
                board[baseCell.y + 1][baseCell.x] = 1;
                board[baseCell.y + 2][baseCell.x] = 1;
                s.push(baseCell);
                s.push({x: baseCell.x, y: baseCell.y + 2});
            };
            if (direction === "left") {
                board[baseCell.y][baseCell.x - 1] = 1;
                board[baseCell.y][baseCell.x - 2] = 1;
                s.push(baseCell);
                s.push({x: baseCell.x - 2, y: baseCell.y});
            };
            if (direction === "right") {
                board[baseCell.y][baseCell.x + 1] = 1;
                board[baseCell.y][baseCell.x + 2] = 1;
                s.push(baseCell);
                s.push({x: baseCell.x + 2, y: baseCell.y});
            };
            continue;
        };
        // 5-3) 상하좌우 4방향중 [이동 가능한 방향]이 없을 때에는 5번으로 돌아간다.
        if (direction == null) {
            continue;
        };

    };
    // 7) (x=1,y=0) 위치의 벽을 지우고 입구로 만든다.
    board[0][1] = 1;
    // 8) (x=배열길이-1,y=배열길이-2) 위치의 벽을 지우고 출구로 만든다.
    board[mazeHeight - 1][mazeWidth - 2] = 1;
    // 6) "방문안함" 상태의 셀을 벽으로, "방문함" 상태의 셀을 길로 화면에 그려낸다.
    let html = "<table cellspacing='0'>";
    for (let y = 0; y < mazeHeight; y += 1) {
        html += "<tr>";
        for (let x = 0; x < mazeWidth; x += 1) {
            // 방문한 셀은 길이 되므로 흰색
            if (board[y][x] === 1) html += "<td style='width:10px;height:10px;'></td>";
            // 방문안한 셀은 벽으로 검은색
            if (board[y][x] === 0) html += "<td style='width:10px;height:10px;background-color:#000;'></td>";
        }
        html += "</tr>";
    }
    document.querySelector("div").innerHTML = html;

    // 램덤 값을 만들어 내는 함수
    function getRandom(start, end) {
        let min = Math.ceil(start);
        let max = Math.floor(end);
        return Math.floor(Math.random() * (max - min + 1)) + min;
    };

    // 이동가능한 방향을 찾는 함수
    function getMovableDirection(base) {
        // 이동 가능한 셀를 찾으면 넣을 배열
        let directions = [];
        // 이동 가능한 방향은 한 방향으로 첫번째칸과 두번째칸이 둘다
        // 1) 방문안함 상태이고 2) 미로의 최외곽선이 아닌 이동 가능한 방향을 말한다.
        // 위쪽으로 이동 가능한지 확인한다.
        if (base.y !== 0 && base.y - 1 !== 0 && base.y - 2 !== 0
            && board[base.y - 1][base.x] === 0 && board[base.y - 2][base.x] === 0) directions.push("up");
        // 아래쪽으로 이동 가능한지 확인한다.
        if (base.y !== mazeHeight - 1 && base.y + 1 !== mazeHeight - 1 && base.y + 2 !== mazeHeight - 1
            && board[base.y + 1][base.x] === 0 && board[base.y + 2][base.x] === 0) directions.push("down");
        // 왼쪽방향으로 이동 가능한지 확인한다.
        if (base.x !== 0 && base.x - 1 !== 0 && base.x - 2 !== 0
            && board[base.y][base.x - 1] === 0 && board[base.y][base.x - 2] === 0) directions.push("left");
        // 오른쪽방향으로 이동 가능한지 확인한다.
        if (base.x !== mazeWidth - 1 && base.x + 1 !== mazeWidth - 1 && base.x + 2 !== mazeWidth - 1
            && board[base.y][base.x + 1] === 0 && board[base.y][base.x + 2] === 0) directions.push("right");
        // 이동가능한 방향이 없으면 null 을 리턴한다.
        if (directions.length === 0) return null;
        // 이동가능한 방향이 있으면 랜덤으로 하나를 선택하여 리턴한다.
        return directions[getRandom(0, directions.length - 1)];
    }
    console.log(board);
    console.log(s);

    // 시작 위치는 (x=1,y=0)
    // 1. 다음을 반복한다.
    // 1-1 현재 위치에 방문했다는 표시를 한다.
    // 1-2 현재 위치가 (x=127, y=58) 출구라면 종료한다.
    // 1-3 현재 위치에서 북, 동, 남, 서 4방향을 순서대로 확인한다.
    // 1-3-1 그 방향으로 이동 가능한지 확인( 벽이 아니고, 외부도 아니고, 지나온 곳도 아닌)
    // 1-3-2 만약 이동 가능하면 현재 위치를 스택에 push 하고 그 방향으로 이동한다.
    // 1-4 만약 1-3에서 4방향 어느 쪽으로도 가지 못하면 스택에서 pop 한 그 위치로  돌아간다.
</script>
</body>
</html>